package com.sos.scheduler.model.objects;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.apache.log4j.Logger;
import org.joda.time.Interval;

import com.sos.scheduler.model.ISOSJsObjStartTimes;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.tools.RunTimeElements;

/**
* \class JSObjUltimos 
* 
* \brief JSObjUltimos - 
* 
* \details
*
* \section JSObjUltimos.java_intro_sec Introduction
*
* \section JSObjUltimos.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 15:21:31
 */

/**
 * @author oh
 *
 */
public class JSObjUltimos extends Ultimos implements ISOSJsObjStartTimes {

	@SuppressWarnings("unused")
	private final String		conClassName	= "JSObjUltimos";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjUltimos.class);

	public JSObjUltimos (SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	@Override
	public RunTimeElements getRunTimeElements(Interval timeRange) {
		RunTimeElements result = new RunTimeElements(timeRange);
		result.putAll(getDtDays(timeRange));
//		Collections.sort(result, DateTimeComparator.getInstance());
		return result;
	}
	
	public RunTimeElements getDtDays(Interval timeRange) {
		RunTimeElements result = new RunTimeElements(timeRange);
		for(JSObjUltimosDay day : getJsObjUltimosDay()) {
			result.putAll( day.getRunTimeElements(timeRange) );
		}
		return result;
	}
	
	public List<JSObjUltimosDay> getJsObjUltimosDay() {
		List<JSObjUltimosDay> result = new ArrayList<JSObjUltimosDay>();
		Iterator<Ultimos.Day> it = getDay().iterator();
		while(it.hasNext()) {
			Day d = it.next();
			JSObjUltimosDay day = new JSObjUltimosDay(objFactory);
			day.setObjectFieldsFrom(d);
			day.setHotFolderSrc(getHotFolderSrc());
			result.add(day);
		}
		return result;
	}
	
	
}
